<?php
/*
Plugin Name: WPSellMore
Plugin URI: http://resell-rights-weekly.com
Description: Automatically use an alternative payment processor for countries where paypal is not supported.
Version: 1.2
Author: RRW - home of the free plr membership
Author URI: http://resell-rights-weekly.com
License: GPLv2
*/



add_action('admin_head', 'wpsellmore_add_my_tc_button');
add_action('admin_enqueue_scripts', 'wpsellmore_tc_css');




ob_start();

if( !function_exists( 'add_action' ) ) {
	header('Status: 403 Forbidden');
	header('HTTP/1.1 403 Forbidden');
	exit;
 }

function wpsellmore_queryvars( $qvars )
{
$qvars[] = 'pmch';
return $qvars;
}



//Inicio Settings



add_action('admin_init', 'wpsellmoresettings_init' );
add_action('admin_menu', 'wpsellmore_create_menu');


// Init plugin options to white list our options
function wpsellmoresettings_init(){
	register_setting( 'wpsellmoresettings_plugin_options', 'wpsellmoresettings_options', 'wpsellmoresettings_validate_options' );


}


function wpsellmore_create_menu(){
    //For user role setup
	$current_user = wp_get_current_user();
	$role=$current_user->roles[0];
	$showrole='administrator';
	add_menu_page("WpSellMore","WPSellMore",8, __FILE__,"wpsellmoresettings_render_form");
	//add_submenu_page(__FILE__,'Payment Buttons','Payment Buttons','administrator','pfense_menu_products','pfense_menu_products');

}






// Render the Plugin options form
function wpsellmoresettings_render_form() {
	?>
	<div class="wrap">

		<!-- Display Plugin Icon, Header, and Description -->
		<div class="icon32" id="icon-options-general"><br></div>
		<h2>WPSellMore Settings</h2>

		<!-- Beginning of the Plugin Options Form -->
		<form method="post" action="options.php">
				<?php if( isset($_GET['settings-updated']) ) { ?>
					<div id="message" class="updated">
					<p><strong><?php _e('Settings saved.') ?></strong></p>
					</div>
				<?php } ?>
			<?php settings_fields('wpsellmoresettings_plugin_options'); ?>
			<?php $options = get_option('wpsellmoresettings_options'); ?>





		 <h4>Countries Supported By PayPal</h4>



			<?php
				// echo 'Valor Dropdown: '. $options['wpsellmoresettings_drp_timezone'] . '<br><br>';

			$supported_ccs = $options['wpsellmoresettings_supported_ccs'];
			if ($supported_ccs == '') {
				$supported_ccs = 'AL&#10;DZ&#10;AD&#10;AO&#10;AI&#10;AG&#10;AR&#10;AM&#10;AW&#10;AU&#10;AT&#10;AZ&#10;BS&#10;BH&#10;BB&#10;BE&#10;BZ&#10;BJ&#10;BM&#10;BT&#10;BO&#10;BA&#10;BW&#10;BR&#10;BN&#10;BG&#10;BF&#10;BI&#10;KH&#10;CA&#10;CV&#10;KY&#10;TD&#10;CL&#10;CN&#10;C2&#10;CO&#10;KM&#10;CD&#10;CG&#10;CK&#10;CR&#10;HR&#10;CY&#10;CZ&#10;DK&#10;DJ&#10;DM&#10;DO&#10;EC&#10;EG&#10;SV&#10;ER&#10;EE&#10;ET&#10;FK&#10;FJ&#10;FI&#10;FR&#10;GF&#10;PF&#10;GA&#10;GM&#10;GE&#10;DE&#10;GI&#10;GR&#10;GL&#10;GD&#10;GP&#10;GU&#10;GT&#10;GN&#10;GW&#10;GY&#10;VA&#10;HN&#10;HK&#10;HU&#10;IS&#10;IN&#10;ID&#10;IE&#10;IL&#10;IT&#10;JM&#10;JP&#10;JO&#10;KZ&#10;KE&#10;KI&#10;KR&#10;KW&#10;KG&#10;LA&#10;LV&#10;LS&#10;LI&#10;LT&#10;LU&#10;MG&#10;MW&#10;MY&#10;MV&#10;ML&#10;MT&#10;MH&#10;MQ&#10;MR&#10;MU&#10;YT&#10;MX&#10;FM&#10;MN&#10;MS&#10;MA&#10;MZ&#10;NA&#10;NR&#10;NP&#10;NL&#10;AN&#10;NC&#10;NZ&#10;NI&#10;NE&#10;NU&#10;NF&#10;NO&#10;OM&#10;PW&#10;PA&#10;PG&#10;PE&#10;PH&#10;PN&#10;PL&#10;PT&#10;QA&#10;RE&#10;RO&#10;RU&#10;RW&#10;SH&#10;KN&#10;LC&#10;PM&#10;VC&#10;WS&#10;SM&#10;ST&#10;SA&#10;SN&#10;RS&#10;SC&#10;SL&#10;SG&#10;SK&#10;SI&#10;SB&#10;SO&#10;ZA&#10;KR&#10;ES&#10;LK&#10;SR&#10;SJ&#10;SZ&#10;SE&#10;CH&#10;TW&#10;TJ&#10;TZ&#10;TH&#10;TG&#10;TO&#10;TT&#10;TN&#10;TR&#10;TM&#10;TC&#10;TV&#10;UG&#10;UA&#10;AE&#10;GB&#10;US&#10;UY&#10;VU&#10;VE&#10;VN&#10;VG&#10;WF&#10;YE&#10;ZM';

				}
			?>


			<!-- General Switching Process -->

					<textarea name="wpsellmoresettings_options[wpsellmoresettings_supported_ccs]" rows="5" cols="50" type='textarea'><?php echo $supported_ccs; ?></textarea><br /><span style="color:#666666;margin-left:2px;"></span>



					<?php

						if ($options['wpsellmoresettings_drp_switchingenabled'] == '') {
							$options['wpsellmoresettings_drp_switchingenabled'] = 'one';
						}

					?>


			<!-- EMERGENCY MODE -->

						<h4>Enable Emergency Mode?</h4>

						<select name='wpsellmoresettings_options[wpsellmoresettings_drp_switchingenabled]'>
							<option value='one' <?php selected('one', $options['wpsellmoresettings_drp_switchingenabled']); ?>>No, Use PayPal and The Alternative Payment Processor Depending on The Country IP.</option>
							<option value='two' <?php selected('two', $options['wpsellmoresettings_drp_switchingenabled']); ?>>Yes, Force All The Products To Use PayPal Only.</option>
							<option value='three' <?php selected('three', $options['wpsellmoresettings_drp_switchingenabled']); ?>>Yes, Force All The Products To Use The Alternative Processor Only.</option>
						</select><br>
						<span style="color:#666666;margin-left:2px;">If you have an emergency, you can force ALL of your products to work with a specific processor (PayPal or an alternative one).</span>



			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>


	</div>
	<?php
}




// Sanitize and validate input. Accepts an array, return a sanitized array.
function wpsellmoresettings_validate_options($input) {
	 // strip html from textboxes
	return $input;
}






















//Fin Settings



function wpsellmore_add_my_tc_button() {
    global $typenow;

    if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) {
   	return;
    }

    if( ! in_array( $typenow, array( 'post', 'page','qsp' ) ) )
        return;
	if ( get_user_option('rich_editing') == 'true') {
		add_filter("mce_external_plugins", "wpsellmore_add_tinymce_plugin");
		add_filter('mce_buttons', 'wpsellmore_register_my_tc_button');
	}
}

function wpsellmore_add_tinymce_plugin($plugin_array) {
   	$plugin_array['wpsellmore_tc_button'] = plugins_url( '/complex-popup-button.js', __FILE__ );
   	return $plugin_array;
}

function wpsellmore_register_my_tc_button($buttons) {
   array_push($buttons, "wpsellmore_tc_button");
   return $buttons;
}

function wpsellmore_tc_css() {
	wp_enqueue_style('wpsellmore-tc', plugins_url('/style.css', __FILE__));
}





//shortcode


function wpsellmore_shortcode( $atts, $content = null ) {

 extract( shortcode_atts( array(
    'target' => 'paypal'
  ), $atts ) );



				//Obtengo opciones
				$options = get_option('wpsellmoresettings_options');



				$supported_ccs = $options['wpsellmoresettings_supported_ccs'];
				if ($supported_ccs == '') {
				$supported_ccs = 'AL&#10;DZ&#10;AD&#10;AO&#10;AI&#10;AG&#10;AR&#10;AM&#10;AW&#10;AU&#10;AT&#10;AZ&#10;BS&#10;BH&#10;BB&#10;BE&#10;BZ&#10;BJ&#10;BM&#10;BT&#10;BO&#10;BA&#10;BW&#10;BR&#10;BN&#10;BG&#10;BF&#10;BI&#10;KH&#10;CA&#10;CV&#10;KY&#10;TD&#10;CL&#10;CN&#10;C2&#10;CO&#10;KM&#10;CD&#10;CG&#10;CK&#10;CR&#10;HR&#10;CY&#10;CZ&#10;DK&#10;DJ&#10;DM&#10;DO&#10;EC&#10;EG&#10;SV&#10;ER&#10;EE&#10;ET&#10;FK&#10;FJ&#10;FI&#10;FR&#10;GF&#10;PF&#10;GA&#10;GM&#10;GE&#10;DE&#10;GI&#10;GR&#10;GL&#10;GD&#10;GP&#10;GU&#10;GT&#10;GN&#10;GW&#10;GY&#10;VA&#10;HN&#10;HK&#10;HU&#10;IS&#10;IN&#10;ID&#10;IE&#10;IL&#10;IT&#10;JM&#10;JP&#10;JO&#10;KZ&#10;KE&#10;KI&#10;KR&#10;KW&#10;KG&#10;LA&#10;LV&#10;LS&#10;LI&#10;LT&#10;LU&#10;MG&#10;MW&#10;MY&#10;MV&#10;ML&#10;MT&#10;MH&#10;MQ&#10;MR&#10;MU&#10;YT&#10;MX&#10;FM&#10;MN&#10;MS&#10;MA&#10;MZ&#10;NA&#10;NR&#10;NP&#10;NL&#10;AN&#10;NC&#10;NZ&#10;NI&#10;NE&#10;NU&#10;NF&#10;NO&#10;OM&#10;PW&#10;PA&#10;PG&#10;PE&#10;PH&#10;PN&#10;PL&#10;PT&#10;QA&#10;RE&#10;RO&#10;RU&#10;RW&#10;SH&#10;KN&#10;LC&#10;PM&#10;VC&#10;WS&#10;SM&#10;ST&#10;SA&#10;SN&#10;RS&#10;SC&#10;SL&#10;SG&#10;SK&#10;SI&#10;SB&#10;SO&#10;ZA&#10;KR&#10;ES&#10;LK&#10;SR&#10;SJ&#10;SZ&#10;SE&#10;CH&#10;TW&#10;TJ&#10;TZ&#10;TH&#10;TG&#10;TO&#10;TT&#10;TN&#10;TR&#10;TM&#10;TC&#10;TV&#10;UG&#10;UA&#10;AE&#10;GB&#10;US&#10;UY&#10;VU&#10;VE&#10;VN&#10;VG&#10;WF&#10;YE&#10;ZM';

				}

			//echo 'Target: ' . $target  . '<br>';


			 $forcing = $options['wpsellmoresettings_drp_switchingenabled'];

			if ( $forcing  == '') {

			$forcing = 'one';

			}

			//echo 'Opciones Force: ' . $forcing  . '<br>';



			switch($forcing) {


				case "one":
					//Default switching process. We Let the things flow.....
					break;
				case "two":
					//Force to show PayPal.

					if ($target=='paypal') {
						return $content;
					}else{
						return '';
					}
					break;

					case "three":
					//Force to show the alternative

					if ($target=='paypal') {
						return '';
					}else{
						return $content;
					}


				break;
			}



				//Inicio IP Get
				$ip_address = wpsellmore_get_ip();
				$wpsellmore_get_ip_details = wpsellmore_get_ip_details($ip_address);
				$city = $wpsellmore_get_ip_details->getElementsByTagName('geoplugin_city')->item(0)->nodeValue;
				$country_name = $wpsellmore_get_ip_details->getElementsByTagName('geoplugin_countryName')->item(0)->nodeValue;
				$country_code = $wpsellmore_get_ip_details->getElementsByTagName('geoplugin_countryCode')->item(0)->nodeValue;


				//$country_code = 'ZZ';


				//echo 'Codigo de Pais: ' . $country_code  . '<br>';
				//echo 'Nombre de Pais: ' . $country_name  . '<br>';


				if ($target == 'paypal') {
					//Mostramos Solo Si es un Country Soportado Por PayPal

							if (strpos($supported_ccs,$country_code) == true) {
								//El Country Opera con PayPal.
								return $content;
							}
				}else{
					//Mostramos Solo Si NO es un Country Soportado Por PayPal

						if (strpos($supported_ccs,$country_code) == false) {
								//El Country No Opera con PayPal.
								return $content;
							}
				}




}

add_shortcode( 'wpsm', 'wpsellmore_shortcode' );




function wpsellmore_get_ip() {

	foreach (array('HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED', 'HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR') as $key) {

		if (array_key_exists($key, $_SERVER) === true) {

			foreach (explode(',', $_SERVER[$key]) as $ip) {

				if (filter_var($ip, FILTER_VALIDATE_IP) !== false) {

				return $ip;

		        }

		    }

		}

	}

}







function wpsellmore_get_ip_details($ipAddr)

{

	$gdm = new DOMDocument();



	$gdm->load('http://www.geoplugin.net/xml.gp?ip='.$ipAddr);



	return $gdm;

}









//Widget


define('wpsellmore_WIDGET_TEXT_DOMAIN','wpsellmore_widget');

require_once('class-shortcode-widget.php');

function wpsm_shortcode_widget_init(){
	register_widget('wpsellmore_Widget');
}
add_action('widgets_init','wpsm_shortcode_widget_init');

function wpsellmore_widget_load_text_domain(){
	load_plugin_textdomain( wpsellmore_WIDGET_TEXT_DOMAIN, false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
}
add_action('plugins_loaded','wpsellmore_widget_load_text_domain');

add_shortcode('wpsm_shortcode_widget_test', 'wpsm_shortcode_widget_test_output');
function wpsm_shortcode_widget_test_output($args){
	return "It works";
}

?>